/*******************************************************************
*
*       Simulated Maximum Likelihood estimation of the
*       stochastic volatiliy model
*       version 1.2
*       February, 1996
*
*       Jon Danielsson (c)
*       Department of Economics
*       University of Iceland
*       101 Reykjavik
*       Iceland
*       e-mail: jond@hag.hi.is
*       ftp  hag.hi.is  
*       WWW  http://www.hag.hi.is/~jond
*       
*       please cite in published work and inform the author.
*
******************************************************************/

#include <iostream>
#include <iomanip>
#include <cmath>
#include <fstream>
#include <cstdio>
//#include <ctype>
#include "common.hpp"
//#include <unistd.h>



#ifdef NRC
#endif
void Simplex(double **p, double y[], int ndim, double ftol,
       double (*funk)(double []), int *nfunk);

void free_matrix(double **m, int r1,int r2, int c1, int c2);
double **matrix(int r1, int r2, int c1, int c2);



extern int monit(double *fmin, double *fmax,double *sim,int *n,
	int *is,int *ncall);


extern int objfun(int *mode, int *n, double *xbb, double *objf, double *objgrd,
int *nstate, int *iuser, double *user);


class opt {
	int nrc_simplex(int dim);

	double *xx;
	double *bxx;

	int svec(int i);

	int sest();
	double best,delta;
	int ps;
public:
	opt(int x) ;
	~opt() ;

	int dim;
	double  *par;
	double  *se;
	double value;
	double tol;
	int iter;
	int result;
	char code[80];
	int hessian;
	int gradient;

	double (*func)(double *);
	void optimize(void);
};

